library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

use work.const.all;

entity exc_inject is
generic (pos: Natural); --position in cause vector where we insert exception
port (
	i_exc: in std_logic; --incoming exception
	i_cause: in exc_vector_type;
	o_cause: out exc_vector_type
);
end entity exc_inject;

architecture behav of exc_inject is
begin
	process(i_cause, i_exc) is
	begin
		for i in 0 to exc_cnt-1 loop
			if (pos = i) then
				o_cause(i) <= i_cause(i) or i_exc;
			else
				o_cause(i) <= i_cause(i);
			end if;
		end loop;
	end process;
end architecture behav;
