library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

use work.const.all;

-- do not complete this before adding all instructions
-- to prevent random exceptions when changing instruction set
entity id_opcode_exc is
port (
	ir: in adr_type;
	exc: out std_logic
);
end entity id_opcode_exc;

architecture behav of id_opcode_exc is
	signal optype: std_logic_vector(3 downto 0);
begin
	optype <= ir(31 downto 28);
	
	exc <= 	'0'	when	optype = "0000"
					or	optype = "0001"
					or	optype = "0010"
					or	optype = "0100"
					or	optype = "1000"
					else
			'1';
end architecture behav;
